'C-Control example for the extended serial display
'===========================================================================
'  ~ Downloaded from http://www.elektronik.de.vu/schalt/fuerpc/extdisp.htm
'  ~ Questions: http://www.elektronik.de.vu/kontakt.htm
'===========================================================================
'  -  Arne Rossius 2001/2002
'  - last updated and corrected: 01.02.2004

Define DispD Port[1]
Define DispC Port[2]
Define Daten Word
Define A Byte

DispD = 1     'Initialisieren der Ports
DispC = 0

'-----------------------------------------------------------------------
'Beispiel fr Datenausgabe "ABC123":
'-----------------------------------------------------------------------
Daten = 0                              'A einstellen (Code 00)
FOR A = 0 TO 13
  LOOKTAB Disp, Daten * 14 + A, DispD
  PULSE DispC
NEXT
DispD = 1                              'Punkt: aus
PULSE DispC                            'Bit fr Punkt
PULSE DispC                            '16. nicht verwendetes Bit
'-----------------------------------------------------------------------
Daten = 1                              'B einstellen (Code 01)
FOR A = 0 TO 13
  LOOKTAB Disp, Daten * 14 + A, DispD
  PULSE DispC
NEXT
DispD = 1                              'Punkt: aus
PULSE DispC                            'Bit fr Punkt
PULSE DispC                            '16. nicht verwendetes Bit
'-----------------------------------------------------------------------
Daten = 2                              'C einstellen (Code 02)
FOR A = 0 TO 13
  LOOKTAB Disp, Daten * 14 + A, DispD
  PULSE DispC
NEXT
DispD = 1                              'Punkt: aus
PULSE DispC                            'Bit fr Punkt
PULSE DispC                            '16. nicht verwendetes Bit
'-----------------------------------------------------------------------
Daten = 31                             '1 einstellen (Code 31)
FOR A = 0 TO 13
  LOOKTAB Disp, Daten * 14 + A, DispD
  PULSE DispC
NEXT
DispD = 1                              'Punkt: aus
PULSE DispC                            'Bit fr Punkt
PULSE DispC                            '16. nicht verwendetes Bit
'-----------------------------------------------------------------------
Daten = 32                             '2 einstellen (Code 32)
FOR A = 0 TO 13
  LOOKTAB Disp, Daten * 14 + A, DispD
  PULSE DispC
NEXT
DispD = 1                              'Punkt: aus
PULSE DispC                            'Bit fr Punkt
PULSE DispC                            '16. nicht verwendetes Bit
'-----------------------------------------------------------------------
Daten = 33                             '3 einstellen (Code 33)
FOR A = 0 TO 13
  LOOKTAB Disp, Daten * 14 + A, DispD
  PULSE DispC
NEXT
PULSE DispC
PULSE DispC
'-----------------------------------------------------------------------
'Beispiel ist hier zuende
'-----------------------------------------------------------------------
END





'--------------------------- Datentabellen ----------------------------------------------
Table Disp
0 0 0 1 0 0 0 0 1 1 1 1 1 1   'A (00 *14)   A...Z = Code 00...25
0 0 0 0 1 1 1 0 1 0 1 1 0 1   'B (01 *14)
0 1 1 0 0 0 1 1 1 1 1 1 1 1   'C (02 *14)
0 0 0 0 1 1 1 1 1 0 1 1 0 1   'D (03 *14)
0 1 1 0 0 0 0 1 1 1 1 1 1 1   'E (04 *14)
0 1 1 1 0 0 0 1 1 1 1 1 1 1   'F (05 *14)
0 1 0 0 0 0 1 0 1 1 1 1 1 1   'G (06 *14)
1 0 0 1 0 0 0 0 1 1 1 1 1 1   'H (07 *14)
1 1 1 1 1 1 1 1 1 0 1 1 0 1   'I (08 *14)
1 0 0 0 0 1 1 1 1 1 1 1 1 1   'J (09 *14)
1 1 1 1 0 0 0 1 1 1 0 1 1 0   'K (10 *14)
1 1 1 0 0 0 1 1 1 1 1 1 1 1   'L (11 *14)
1 0 0 1 0 0 1 1 0 1 0 1 1 1   'M (12 *14)
1 0 0 1 0 0 1 1 0 1 1 1 1 0   'N (13 *14)
0 0 0 0 0 0 1 1 1 1 1 1 1 1   'O (14 *14)
0 0 1 1 0 0 0 0 1 1 1 1 1 1   'P (15 *14)
0 0 0 0 0 0 0 0 1 1 1 1 1 0   'Q (16 *14)
0 0 1 1 0 0 0 0 1 1 1 1 1 0   'R (17 *14)
0 1 0 0 1 0 0 0 1 1 1 1 1 1   'S (18 *14)
0 1 1 1 1 1 1 1 1 0 1 1 0 1   'T (19 *14)
1 0 0 0 0 0 1 1 1 1 1 1 1 1   'U (20 *14)
1 1 1 1 0 0 1 1 1 1 0 0 1 1   'V (21 *14)
1 0 0 1 0 0 1 1 1 1 1 0 1 0   'W (22 *14)
1 1 1 1 1 1 1 1 0 1 0 0 1 0   'X (23 *14)
1 1 1 1 1 1 1 1 0 1 0 1 0 1   'Y (24 *14)
0 1 1 0 1 1 1 1 1 1 0 0 1 1   'Z (25 *14)
1 1 1 1 1 1 1 1 1 1 1 1 1 1   '  (26 *14)   Leerstelle: 26
0 0 0 0 0 0 0 0 0 0 0 0 0 0   '# (27 *14)   Alles an: 27
1 1 1 1 1 1 1 1 1 1 1 1 1 1   '  (28 *14)   Platz fr eigene Zeichen: 28, 29
1 1 1 1 1 1 1 1 1 1 1 1 1 1   '  (29 *14)
0 0 0 0 0 0 1 1 1 1 0 0 1 1   '0 (30 *14)   Zahlen: 0...9 = Code 30...39
1 0 0 1 1 1 1 1 1 1 0 1 1 1   '1 (31 *14)
0 0 1 0 1 1 1 0 1 1 1 0 1 1   '2 (32 *14)
0 0 0 0 1 1 1 0 1 1 1 1 1 1   '3 (33 *14)
1 0 0 1 1 0 0 0 1 1 1 1 1 1   '4 (34 *14)
0 1 1 0 1 0 0 1 1 1 1 1 1 0   '5 (35 *14)
0 1 0 0 0 0 0 0 1 1 1 1 1 1   '6 (36 *14)
0 0 0 1 1 0 1 1 1 1 1 1 1 1   '7 (37 *14)
0 0 0 0 0 0 0 0 1 1 1 1 1 1   '8 (38 *14)
0 0 0 0 1 0 0 0 1 1 1 1 1 1   '9 (39 *14)
Tabend

